; *****************************************************************************
; *** Soubor:	Math.inc													***
; ***																		***
; *** Matematicke operace													***
; ***																		***
; *** (C) MEFI s.r.o.														***
;																			***
; 																			***	
;Seznam Maker:																***
;	SIN_REAL	COS_REAL	TAN_REAL	RAD_REAL	PI_REAL		DEG_REAL	***
;	ASIN_REAL	ACOS_REAL													***	
;	SQ_REAL		SQRT_REAL	SCALE_REAL	MOD_REAL	XTRCT_REAL	YX_REAL		***
;	F2XM1_REAL	YL2X_REAL	YL2X1_REAL										***
;	ROUND_REAL	FLOOR_REAL	TRUNC_REAL										***
;	F1_REAL		Z_REAL		L2T_REAL	L2E_REAL	LG2_REAL	LN2_REAL	***
;	STW_REAL	INT_REAL													***
;																			***		
;Spolecne vlastnosti:														***
;Bezoperandove makra ocekavaji nastaveno na vstupu DR_REAL.					***
;Makra s parametrem predpokladaji vsechny promenne typu REAL.				***
;Prefix REAL se u promennych nepouziva.										***
;Makra na rozdil od zakladnich instrukci pro realne cisla automaticky 		***
;nezanechavaji nastaven celociselny registr DR (nutno pouzit INT_REAL).		***
;																			***	
; *****************************************************************************

CONTROL_T_MACRO pos

;.....

;SIN_REAL .... 	sinus DR_REAL [rad]
DEF_T_MACRO	SIN_REAL 
			pushf
			cli
			finit
			fld		qword ptr DR_REAL
			fsin	
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;COS_REAL .... 	cosinus DR_REAL [rad]
DEF_T_MACRO	COS_REAL 
			pushf
			cli
			finit
			fld		qword ptr DR_REAL
			fcos	
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;TAN_REAL .... 	tangens DR_REAL [rad]
DEF_T_MACRO	TAN_REAL 
			pushf
			cli
			finit
			fld		qword ptr DR_REAL
			fsincos						;0=cos	1=sin
			fdivp	st(1),st			;0=tan	
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;PI_REAL ....	nacte PI do DR_REAL
DEF_T_MACRO	PI_REAL 
			pushf
			cli
			fldpi
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;RAD_REAL ....	prevod stupne->radiany v DR_REAL
DEF_T_MACRO	RAD_REAL 
 T_LOCAL RAD180, RAD_R1	
			pushf
			cli
			finit
			jmp		RAD_R1
 RAD180 	dq		180.0
 RAD_R1:	fld		qword ptr DR_REAL
			fldpi
			fmulp	st(1),st
			fdiv	qword ptr RAD180	
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;DEG_REAL ....	prevod radiany->stupne v DR_REAL
DEF_T_MACRO	DEG_REAL 
 T_LOCAL DEG180, DEG_R1	
			pushf
			cli
			finit
			jmp		DEG_R1
 DEG180 	dq		180.0
 DEG_R1:	fld		qword ptr DR_REAL
			fmul	qword ptr DEG180
			fldpi
			fdivp	st(1),st
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;ASIN_REAL ... 	Arcussinus DR_REAL [rad]
;				vstup:  0=< DR_REAL =< 1
;				vystup: 0=< DR_REAL =< PI/2
DEF_T_MACRO	ASIN_REAL 
	CODE_DEBUG SEGMENT PARA PUBLIC USE16 'CODE'
	EXTRN ARCSIN:FAR	
	CODE_DEBUG ENDS
			pushf
			cli
			finit
			fld		qword ptr DR_REAL
			CALLF   <CODE_DEBUG:ARCSIN>,SelSupDEBUGC_SH
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;ACOS_REAL ... 	Arcuscosinus DR_REAL [rad]
;				vstup:  0=< DR_REAL =< 1
;				vystup: 0=< DR_REAL =< PI/2
DEF_T_MACRO	ACOS_REAL 
	CODE_DEBUG SEGMENT PARA PUBLIC USE16 'CODE'
	EXTRN ARCCOS:FAR	
	CODE_DEBUG ENDS
			pushf
			cli
			finit
			fld		qword ptr DR_REAL
			CALLF   <CODE_DEBUG:ARCCOS>,SelSupDEBUGC_SH
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;SQ_REAL ....	Druha mocnina DR_REAL
DEF_T_MACRO	SQ_REAL 
			pushf
			cli
			finit
			fld		qword ptr DR_REAL
			fmul	st,st(0)
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;SQRT_REAL ....	Druha odmocnina DR_REAL
DEF_T_MACRO	SQRT_REAL 
			pushf
			cli
			finit
			fld		qword ptr DR_REAL
			fsqrt
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;SCALE_REAL ...	Binarni posun: DR_REAL*2^(par)
DEF_T_MACRO	SCALE_REAL par1
			pushf
			cli
			finit
			fld		qword ptr par1
			fld		qword ptr DR_REAL	;0=DR		1=par
			fscale
			fstp	qword ptr DR_REAL
			fstp	st(0)
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;MOD_REAL ...	Zbytek po deleni: MOD(DR_REAL/(par))
DEF_T_MACRO	MOD_REAL par1
			pushf
			cli
			finit
			fld		qword ptr par1
			fld		qword ptr DR_REAL	;0=DR			1=par
			fprem						;0=mod(DR/par)	1=par
			fstp	qword ptr DR_REAL
			fstp	st(0)
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;XTRCT_REAL ...	Rozdeli mantisu a exponent z DR_REAL
;				vystup: DR_REAL=mantisa,  par1=exponent
DEF_T_MACRO	XTRCT_REAL par1
			pushf
			cli
			finit
			fld		qword ptr DR_REAL	;0=DR
			fxtract						;0=mantisa		1=exp
			fstp	qword ptr DR_REAL
			fstp	qword ptr par1
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....


;ROUND_REAL ... Zaokrouhleni na nelblizsi cislo v DR_REAL
DEF_T_MACRO	ROUND_REAL
	CODE_UTIL SEGMENT PARA PUBLIC USE16 'CODE'
	EXTRN ROUND_REAL_PROC:FAR	
	CODE_UTIL ENDS
			pushf
			cli
			CALLF   <CODE_UTIL:ROUND_REAL_PROC>,SelSupCUTIL_SH
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;TRUNC_REAL ... Oseknuti v DR_REAL
DEF_T_MACRO	TRUNC_REAL
	CODE_UTIL SEGMENT PARA PUBLIC USE16 'CODE'
	EXTRN TRUNC_REAL_PROC:FAR	
	CODE_UTIL ENDS
			pushf
			cli
			CALLF   <CODE_UTIL:TRUNC_REAL_PROC>,SelSupCUTIL_SH
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....


;FLOOR_REAL ... Zaokrouhleni dolu v DR_REAL
DEF_T_MACRO	FLOOR_REAL
	CODE_UTIL SEGMENT PARA PUBLIC USE16 'CODE'
	EXTRN FLOOR_REAL_PROC:FAR	
	CODE_UTIL ENDS
			pushf
			cli
			CALLF   <CODE_UTIL:FLOOR_REAL_PROC>,SelSupCUTIL_SH
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;F2XM1_REAL ...	Vypocet (2^DR_REAL)-1 
DEF_T_MACRO	F2XM1_REAL
			pushf
			cli
			finit
			fld		qword ptr DR_REAL
			f2xm1
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;YL2X_REAL ...	Vypocet  par*log2(DR_REAL)
DEF_T_MACRO	YL2X_REAL par1
			pushf
			cli
			finit
			fld		qword ptr par1
			fld		qword ptr DR_REAL	;0=DR			1=par
			fyl2x			
			fstp	qword ptr DR_REAL
			fstp	st(0)
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;YL2X1_REAL ...	Vypocet  par*log2(DR_REAL+1)
DEF_T_MACRO	YL2X1_REAL par1
			pushf
			cli
			finit
			fld		qword ptr par1
			fld		qword ptr DR_REAL	;0=DR			1=par
			fyl2xp1			
			fstp	qword ptr DR_REAL
			fstp	st(0)
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;YX_REAL ....	Vypocet DR_REAL^par
DEF_T_MACRO	YX_REAL par1
			pushf
			cli
			finit
			fld		qword ptr par1
			fld		qword ptr DR_REAL	;0=DR			1=par
			fyl2x						;0=par*log2(dr)	1=par
			fst		st(1)				;0=par*log2(dr)	1=par*log2(dr)
			fistp	qword ptr _POMBUF_REAL
			fild	qword ptr _POMBUF_REAL
			fst		st(2)				;0=int			1=par*log2(dr)	2=int
			fsubr	st,st(1)			;0=des			1=par*log2(dr)	2=int
			f2xm1						;0=2^x-1		1=par*log2(dr)	2=int
			fld1						;0=1			1=2^x-1			2=par*log2(dr)		3=int
			fadd	st,st(1)			;0=2^x			1=2^x-1			2=par*log2(dr)		3=int
	        fxch    ST(3)               ;0=int			1=2^x-1			2=par*log2(dr)		3=2^x
    	    fxch    ST(1)               ;0=2^x-1		1=int			2=par*log2(dr)		3=2^x
        	fxch    ST(3)               ;0=2^x			1=int			2=par*log2(dr)		3=2^x-1
        	fscale
			fstp	st(1)
			fstp	st(1)
			fstp	st(1)
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;F1_REAL ....	nacte 1.0 do DR_REAL
DEF_T_MACRO	F1_REAL 
			pushf
			cli
			fld1
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;Z_REAL ....	nacte 0.0 do DR_REAL
DEF_T_MACRO	Z_REAL 
			pushf
			cli
			fldz
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;L2T_REAL ....	nacte log2(10) do DR_REAL
DEF_T_MACRO	L2T_REAL 
			pushf
			cli
			fldl2t
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;L2E_REAL ....	nacte log2(e) do DR_REAL
DEF_T_MACRO	L2E_REAL 
			pushf
			cli
			fldl2e
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;LG2_REAL ....	nacte log10(2) do DR_REAL
DEF_T_MACRO	LG2_REAL 
			pushf
			cli
			fldlg2
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....

;LN2_REAL ....	nacte loge(2) do DR_REAL
DEF_T_MACRO	LN2_REAL 
			pushf
			cli
			fldln2
			fstp	qword ptr DR_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON


;.....

;STW_REAL ..nacte status koprocesoru do DR
;			bit 0 .... IE = neplatna operace (napr. je v registru nekonecno)
;			bit 1 .... DE = nenormalizovany operand
;			bit 2 .... ZE = deleni nulou
;			bit 3 .... OE = preteceni
;			bit 4 .... UE = podteceni
;			bit 5 .... PE = presnost
DEF_T_MACRO	STW_REAL 
			pushf
			cli
			FSTSW	WORD PTR _POMBUF_REAL
			wait
			xor		ecx,ecx
			mov		cx,word ptr _POMBUF_REAL
			popf
END_T_MACRO T_NORMAL, C_0, D_ON


;.....

;INT_REAL ..... prevod DR_REAL->DR (QWRD)
DEF_T_MACRO	INT_REAL 
			pushf
			cli
			finit
			fld		qword ptr DR_REAL
			fistp	qword ptr _POMBUF_REAL
			wait
			mov		ecx,dword ptr _POMBUF_REAL
			mov		edx,dword ptr _POMBUF_REAL+4
			popf
END_T_MACRO T_NORMAL, C_0, D_ON

;.....


